Package org.apache.solr.common.params

## Interface ShardParams

    public interface ShardParams

Parameters used for distributed search.

When adding a new parameter here, please also add the corresponding one-line test case in the ShardParamsTest class.

### Field Summary

Fields
`static String` `_ROUTE_`
`static String` `DISTRIB_SINGLE_PASS` Force a single-pass distributed query? (true/false)
`static String` `IDS` IDs of the shard documents
`static String` `IS_SHARD` whether the request goes to a shard
`static String` `QUERY_ID` UUID of the query
`static String` `REPLICA_LOCAL` Value denoting local replicas
`static String` `REPLICA_RANDOM` Value denoting randomized replica sort
`static String` `REPLICA_STABLE` Value denoting stable replica sort
`static String` `REQUIRE_ZK_CONNECTED` Throw an error from search requests when the "shards.tolerant" param has this value and ZooKeeper is not connected.
`static String` `ROUTING_DIVIDEND` configure dividend param for stable replica sort
`static String` `ROUTING_HASH` configure hash param for stable replica sort
`static String` `SHARD_NAME` The requested shard name
`static String` `SHARD_URL` Deprecated. This was an internally used param never ment for clients to specify; it is no longer used by Solr.
`static String` `SHARDS` the shards to use (distributed configuration)
`static String` `SHARDS_INFO` Request detailed match info for each shard (true/false)
`static String` `SHARDS_PREFERENCE` Shards sorting rules
`static String` `SHARDS_PREFERENCE_NODE_WITH_SAME_SYSPROP` Node with same system property sort rule
`static String` `SHARDS_PREFERENCE_REPLICA_BASE` Replica base/fallback sort rule
`static String` `SHARDS_PREFERENCE_REPLICA_LEADER` Replica leader status sort rule, value= true/false
`static String` `SHARDS_PREFERENCE_REPLICA_LOCATION` Replica location sort rule
`static String` `SHARDS_PREFERENCE_REPLICA_TYPE` Replica type sort rule
`static String` `SHARDS_PURPOSE` query purpose for shard requests
`static String` `SHARDS_QT` The Request Handler for shard requests
`static String` `SHARDS_ROWS` per-shard start and rows
`static String` `SHARDS_START`
`static String` `SHARDS_TOLERANT` Should things fail if there is an error? (true/false/"requireZkConnected")

### Method Summary

Static Methods
`static boolean` `getShardsTolerantAsBool​(SolrParams params)` Parse the "shards.tolerant" param from `params` as a boolean; accepts "requireZkConnected" as a valid value indicating `false`.

### Field Detail

#### SHARDS

    static final String SHARDS

the shards to use (distributed configuration)

See Also:
  Constant Field Values

#### QUERY_ID

    static final String QUERY_ID

UUID of the query

See Also:
  Constant Field Values

#### SHARDS_ROWS

    static final String SHARDS_ROWS

per-shard start and rows

See Also:
  Constant Field Values

#### SHARDS_START

    static final String SHARDS_START

See Also:
  Constant Field Values

#### IDS

    static final String IDS

IDs of the shard documents

See Also:
  Constant Field Values

#### IS_SHARD

    static final String IS_SHARD

whether the request goes to a shard

See Also:
  Constant Field Values

#### SHARD_URL

    @Deprecated
    static final String SHARD_URL

Deprecated.
This was an internally used param never ment for clients to specify; it is no longer used by Solr.
The requested URL for this shard

See Also:
  Constant Field Values

#### SHARD_NAME

    static final String SHARD_NAME

The requested shard name

See Also:
  Constant Field Values

#### SHARDS_QT

    static final String SHARDS_QT

The Request Handler for shard requests

See Also:
  Constant Field Values

#### SHARDS_INFO

    static final String SHARDS_INFO

Request detailed match info for each shard (true/false)

See Also:
  Constant Field Values

#### SHARDS_TOLERANT

    static final String SHARDS_TOLERANT

Should things fail if there is an error? (true/false/"requireZkConnected")

See Also:
  Constant Field Values

#### SHARDS_PURPOSE

    static final String SHARDS_PURPOSE

query purpose for shard requests

See Also:
  Constant Field Values

#### SHARDS_PREFERENCE

    static final String SHARDS_PREFERENCE

Shards sorting rules

See Also:
  Constant Field Values

#### SHARDS_PREFERENCE_REPLICA_TYPE

    static final String SHARDS_PREFERENCE_REPLICA_TYPE

Replica type sort rule

See Also:
  Constant Field Values

#### SHARDS_PREFERENCE_REPLICA_LOCATION

    static final String SHARDS_PREFERENCE_REPLICA_LOCATION

Replica location sort rule

See Also:
  Constant Field Values

#### SHARDS_PREFERENCE_REPLICA_LEADER

    static final String SHARDS_PREFERENCE_REPLICA_LEADER

Replica leader status sort rule, value= true/false

See Also:
  Constant Field Values

#### SHARDS_PREFERENCE_NODE_WITH_SAME_SYSPROP

    static final String SHARDS_PREFERENCE_NODE_WITH_SAME_SYSPROP

Node with same system property sort rule

See Also:
  Constant Field Values

#### SHARDS_PREFERENCE_REPLICA_BASE

    static final String SHARDS_PREFERENCE_REPLICA_BASE

Replica base/fallback sort rule

See Also:
  Constant Field Values

#### REPLICA_LOCAL

    static final String REPLICA_LOCAL

Value denoting local replicas

See Also:
  Constant Field Values

#### REPLICA_RANDOM

    static final String REPLICA_RANDOM

Value denoting randomized replica sort

See Also:
  Constant Field Values

#### REPLICA_STABLE

    static final String REPLICA_STABLE

Value denoting stable replica sort

See Also:
  Constant Field Values

#### ROUTING_DIVIDEND

    static final String ROUTING_DIVIDEND

configure dividend param for stable replica sort

See Also:
  Constant Field Values

#### ROUTING_HASH

    static final String ROUTING_HASH

configure hash param for stable replica sort

See Also:
  Constant Field Values

#### _ROUTE_

    static final String _ROUTE_

See Also:
  Constant Field Values

#### DISTRIB_SINGLE_PASS

    static final String DISTRIB_SINGLE_PASS

Force a single-pass distributed query? (true/false)

See Also:
  Constant Field Values

#### REQUIRE_ZK_CONNECTED

    static final String REQUIRE_ZK_CONNECTED

Throw an error from search requests when the "shards.tolerant" param has this value and ZooKeeper is not connected.

See Also:
  `getShardsTolerantAsBool(SolrParams)`, Constant Field Values

### Method Detail

#### getShardsTolerantAsBool

    static boolean getShardsTolerantAsBool​(SolrParams params)

Parse the "shards.tolerant" param from `params` as a boolean; accepts "requireZkConnected" as a valid value indicating `false`.

By default, returns `false` when "shards.tolerant" is not set in `params`.